/*
	LLC - link log converter(^^;

	for LSI-C/MS-DOS, GCC/linux(intel) Copyrigth (c) funaki&RADD

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <time.h>

/* 0.40 */
#if __LSIC__
#  include <dos.h>
#  include <farstr.h>
#  define	MALLOC			farmalloc
#  define	FREE			farfree
#  define   MEMCPY2N(x,y,i)	far_memcpy(MK_FP(bss,&x),y,i)
#  define   MEMCPY2F(x,y,i)	far_memcpy(x,MK_FP(bss,&y),i)
#  define	FAR				far
#else
#  if __TSC__
#    include <dos.h>
#    include <io.h>
#    include <alloc.h>
#    define						MALLOC	_fmalloc
#    define						FREE	_ffree
#    define		MEMCPY2N(x,y,i)	_fmemcpy(MK_FP(bss,&x),y,i)
#    define		MEMCPY2F(x,y,i)	_fmemcpy(x,MK_FP(bss,&y),i)
#    define						FAR		far
#  else
/* for flat memory model, like 68000 */
#    include <unistd.h>
#    define					MALLOC	malloc
#    define					FREE	free
#    define	MEMCPY2F(x,y,i)	memcpy(x,y,i)
#    define	MEMCPY2N(x,y,i)	memcpy(x,y,i)
#    define					FAR		
/*#    define NULL			((void *)0)*/
#  endif
#endif

#define		READ_BUFFER_SIZE		(16384)	/* Disk Read Buffer Size <32768  0.30E    */
#define		MAX_LINE_LENGTH 		(16384)	/* Ps̒					 0.30E	  */
#define		MAX_TITLE_LINE_LENGTH 	(90)	/* ȯċyMSGLINKtق̂Ps̒ */
#define		MAX_TITLE_LINE_NUM		(10)	/* ȯċyMSGLINKtق̍ős   */
#define		MAXXFER					 (5)	/* ȯݸĂȯĐ(ȯĊ܂)   */
#define		MAXMES					(16384)	/* őL                    0.40     */
											/* ȯݸœ]Ă݂̂̂̐     */

/* s̕2 */
#define		EOL0					(0x0d)	/* CR */
#define		EOL						(0x0a)	/* LF */

#define		TRUE					(1)		/* ^ */
#define		FALSE					(0)		/* U */

char	*copyright="LLC - Copyright RADD and fnk";
char	*ver = "0.52";						/* ްޮݕ\Lp   */
char	*verx = "0.12";						/* ްޮݕ\Lp   */

FILE	*oldlog;							/* ϊ̧ٽذ */
FILE	*newlog;							/* ϊ̧ٽذ */

short	open_log = 0;
short	open_cfg = 0;


long	oldsize;							/* ϊُ̧  */
unsigned char	readbuff[READ_BUFFER_SIZE];	/* 1s擾ر      */

/* ǂݍł1s */
unsigned char	line[MAX_LINE_LENGTH];
/* wb_ۑp̃obt@ */
unsigned char	linesave[MAX_TITLE_LINE_NUM][MAX_TITLE_LINE_LENGTH];

short		fileend = FALSE;
short		debug = TRUE;
short		messtat;

long FAR	*ownserial;						/* 0.30E ̃lbgł̃VAwb_f[^ */
long FAR	*message_num[MAXXFER];			/* elbgł̃bZ[Wԍ */
short FAR	*origin_net;					/* 0.30E ܂ꂽlbg */

short		wrap	= FALSE;				/* 0.40 obt@ꏄ */
short		linknum = 0;
short		oldlinknum = 0;
short		tidx;
short		flg_OverWrite = 0;				/* ds׸ 0: 1:Ȃ */
short		flg_hist = 1;					/*    1: 0:Ȃ */
short		flg_force = 0;					/* ϊ׸ 1: 0:Ȃ */

short		netxfer	=    3;					/* ]Ălbg̏l */
short		mesmax	= 6400;					/* 郁bZ[W̍ő */

unsigned char	net[MAXXFER][10];

unsigned char	border1[20];
unsigned char	border2[20];
unsigned char	border3[100];

unsigned char	bltitle[20];
unsigned char	xfertitle[20];
unsigned char	response[20];

char			bakfile[256];						/* ޯ̧ */
char			datfile[256];						/* ް̧߽  */
char			bakname[13];						/* ޯ̧ٖ */
char			datname[13];						/* ް̧ٖ */

/* IDėp{ԍ mod 0.40 */
long	st_no[MAXXFER - 1];

/* ȯݸSID */
unsigned char	blinkid[20];
unsigned char   net_header[20];

/* رͯތ */
unsigned short	shead_num = 0;

/* үޗ} 0.30D */
short	disp_mes = FALSE;
short	idmod = FALSE;

#if ( __LSIC__ || __TSC__ || __TURBOC__ )
short	bss;	/* data segmanet */
struct SREGS sregs;
#endif

char	*chk_tbl[] = { 
					 "BASENET",				/* [ 0]ްȯĖ        */
					 "LINKNET1",			/* [ 1]ݸȯĖ1      */
					 "LINKNET2",			/* [ 2]ݸȯĖ2      */
					 "LINKNET3",			/* [ 3]ݸȯĖ3      */
					 "LINKNET4",			/* [ 4]ݸȯĖ4      */
					 "MAXNETNUM",			/* [ 5]őȯĐ        */
					 "BNUMMAX",				/* [ 6]ۑő吔       */
					 "HEADBORDER1",			/* [ 7]ͯޕ1      */
					 "HEADBORDER2",			/* [ 8]ͯޕ2      */
					 "HEADBORDER3",			/* [ 9]ͯޕ3      */
					 "NETHEADER",			/* [10]رͯޕ   */
					 "SHEADNUM",			/* [11]رͯތ     */
					 "BLTITLE",				/* [12]ݸްޖ       */
					 "XFERTITLE",			/* [13]ݸͯ          */
					 "RESTITLE",			/* [14]ڽͯ           */
					 "BLINKID",				/* [15]ݸSID      */
					 "IDMODFLG",			/* [16]ID׸        */
					 "LINKID1",				/* [17]Đ1           */
					 "LINKID2",				/* [18]Đ2           */
					 "LINKID3",				/* [19]Đ3           */
					 "LINKID4",				/* [20]Đ4           */
					 "BAKDIR",				/* [21]ޯިڸ  */
					 "DATDIR",				/* [22]ްިڸ  */
					 "NOMORECONV",			/* [23]d         */
					 "LOGDIR",				/* [24]۸ޏިڸ */
					 "MAKEHIST",			/* [25]       */
					 ""						/* Ȱ */
					};

	short	tbl_num;						/* ܰðٗvf */

/* ߐ錾 */
short	init_proc( char *dat );					/* get stored data */
short	store( char *dat );
short	get_cfg( char *cfg );
short	procline( void );
void	readline( FILE *fp );					/* 0.40 */
unsigned char	readchar( FILE *fp );			/* 0.30E */
void	makehead( unsigned char *l1, long shead_no );
void	makeres( unsigned char *l1, unsigned char *l2, long bnum );
long	getnum( unsigned char *l1, char sep );
long    chknum( unsigned char *l1, char sep );
long	searchorigin( short net, long bnum );
short	searchchar( unsigned char *l1, char sep );
short	get_pam( char *dst_str, char *src_str );
void	helpdisp( char *name, char *mes );
long	getsize( FILE *fp );
short	readdat( FILE *fp, char FAR *buff, unsigned sizes);
short	writedat( FILE *fp, char FAR *buff, unsigned sizes);
void	fclose_all( void );
void	exit_free( void );
void	splpath( char *src, char *drive, char *path, char *fname, char *ext,
							short dflg, short pflg, short fflg, short eflg );
void	chk_ini( short para_max, char *para[], char *cfgname, char *orgfile, char *tmpfile );
short	mk_bkname( void );
void	get_llctime( char *llc_time );
void	mk_llchist( void );
short	chk_hist( void );

int
main( int argc, char *argv[] )
{
	char	orgfile[256];						/* ϊ̧ٖ */
	char	tmpfile[256];						/* ϊ̧ٖ */
	char	cfgfile[256];						/* config file 0.40 */
	short	i;									/* 0.40 */
	short	linkdiff;							/* 0.40 */
	short	sts_cfg;
	char	wk_ch[256];

#if ( __LSIC__ || __TURBOC__ || __TSC__ )
		fprintf( stderr, "Link Log Converter -LLC- V%s (c)funaki&RADD\n", ver );
#else
		fprintf( stderr, "Link Log Converter -LLC- for X68 Ver%s (c)RADD&funaki\n", verx );
		fprintf( stderr, "         Base Version is LLC for MS-DOS Ver.%s \n\n", ver );
#endif

#if ( __LSIC__ || __TSC__ || __TURBOC__ )
	/* get near data segment */
	segread( &sregs );
	bss = sregs.ds;
#endif

#if _DEBUG
printf( "DEBUG MODE!\n" );
#endif

	if ( argc == 1 ) {
		/* Ұ */
		helpdisp( argv[0], " " );
		exit(-1);
	}


	/*  */
	chk_ini( argc, argv, cfgfile, orgfile, tmpfile );

	if ( disp_mes == TRUE ) {
		printf( "cfgfile=[%s]\n", cfgfile );
		printf( "orgfile=[%s]\n", orgfile );
		printf( "tmpfile=[%s]\n", tmpfile );
		printf( "bakname=[%s]\n", bakname );
		printf( "datname=[%s]\n", datname );
	}

	fileend = FALSE;
	for( i = 0; ; i++ ) {
		if ( chk_tbl[i] == '\0' ) {
			break;
		}
	}
	tbl_num = i;

	/* `َ̧擾 */
	sts_cfg = get_cfg( cfgfile );
	if ( sts_cfg != 0 ) {
		if ( sts_cfg == -1 ) {
			/* 0.40 G[̓bZ[W}~ło͂ */
			sprintf( wk_ch, "  `t@C(%s)疳(T-T)\n", cfgfile );
			helpdisp( argv[0], wk_ch );
			exit(-1);
		}
	}

	if ( disp_mes == TRUE ) {
		printf( "cfgfile=[%s]\n", cfgfile );
		printf( "orgfile=[%s]\n", orgfile );
		printf( "tmpfile=[%s]\n", tmpfile );
		printf( "bakfile=[%s]\n", bakfile );
		printf( "datfile=[%s]\n", datfile );
	}

	/* ̧ٵ */
	if ( ( oldlog = fopen( orgfile, "rb" ) ) == NULL ) {
		fprintf( stderr, "  ȃOt@C悧`(T_T)->[%s]\n", orgfile );
		exit(-1);
	} else {
		oldsize = getsize( oldlog );
		if ( disp_mes == TRUE ) {
			printf( "  log file(%s) size is %ld bytes\n", orgfile, oldsize );
		}
	}
	/*  */
	if ( chk_hist() != 0 ) {
		fprintf( stderr, "ς݃t@Cł̂ŏI܂.\n" );
		fprintf( stderr, "                     Ώۃt@C[%s]\n", orgfile );
		fprintf( stderr, "                     Ώۃ{[h  [%s]\n", bltitle );
		fclose(oldlog);
		exit(-1);
	}
	/* ߲擪 */
	fseek( oldlog, 0L, SEEK_SET );

	/* ̧ٵ */
	if ( ( newlog = fopen( tmpfile, "wb" ) ) == NULL ) {
		/* ݎs */
		fprintf( stderr, "  ̧قȂ񂾂悧`(T-T)->[%s]\n", tmpfile );
		fclose(oldlog);
		exit(-1);
	}
	/* ̧ٵ׸ */
	open_log = 1;

	/* allocate memory */
	for ( i = 0; i < netxfer; i++ ) {		/* 0.30E */
		if ( ( message_num[i] = MALLOC( mesmax * sizeof(long) ) ) == NULL ) {
			fprintf(stderr, "  `Ȃ́ABNUMMAXĂ\n" );
			fclose_all();
			exit(1);
		}
	}
	/* 0.30E */
	if ( ( ownserial = MALLOC( mesmax * sizeof(long) ) ) == NULL ) {
		fprintf( stderr, "@Ȃ́ABNUMMAXĂ\n" );
		for ( i = 0; i < netxfer; i++ ) {
			FREE( message_num[i] );
		}
		fclose_all();
		exit(1);
	}
	if ( ( origin_net = MALLOC( mesmax * sizeof(short) ) ) == NULL ) {
		fprintf( stderr, " ƏȂ́ABNUMMAXĂ\n" );
		FREE( ownserial );
		for ( i = ( netxfer - 1 ); i >= 0; i-- ) {
			FREE( message_num[i] );
		}
		fclose_all();
		exit(1);
	}

	linknum = 0;
	oldlinknum = 0;
	if ( ( init_proc( datfile ) ) != 0 ) {
		fprintf( stderr, "f[^t@C(%s)̓ǂݍ݂Ɏs悧` \n", datfile );
		FREE( origin_net );
		FREE( ownserial );
		for ( i = ( netxfer - 1 ); i >= 0; i-- ) {
			FREE( message_num[i] );
		}
		fclose_all();
		exit(-1);
	}

	fileend = FALSE;
	messtat = 0;
	tidx = 0;
	/* Ҳݏٰ */
	while ( !fileend ) {
		readline( oldlog );
		if ( procline() ) {
			do {
				strcpy( linesave[tidx], line );
				tidx++;
				readline( oldlog );
			} while ( procline() != 0 );
			/* write saved lines, but last line not write */
			for ( i = 0; i < tidx; i++ ) {
				if ( fputs( linesave[i], newlog ) != 0 ) {
					/* ݎs */
					/* ү */
					exit_free();
					fclose_all();
				}
			}
			tidx = 0;
		}
		fputs( (char *)line, newlog );
	}

	if ( disp_mes != TRUE ) {
		printf("\n");
	}

	/* Şٸ۰ */
	fclose_all();
	open_log = 0;

	/* ̧ޯ */
	sprintf( wk_ch, "copy %s %s > NUL", orgfile, bakfile );
	system( wk_ch );
	/* ؼٍ폜 */
	remove( orgfile );

	/* ϊ̧ٺ߰ */
	sprintf( wk_ch, "copy %s %s > NUL", tmpfile, orgfile );
	system( wk_ch );
	/* ؍폜 */
	remove( tmpfile );

	if ( ( linkdiff = linknum - oldlinknum ) < 0 ) {
		linkdiff = linkdiff + mesmax;
	}
	printf( "  link num is %hd(link idx %hd to %hd, wrap is %hd)\n", linkdiff,
																	 oldlinknum,
																	 linknum,
																	 wrap
																	 );
	printf( " back up File is %s \n", bakfile );

	if ( ( store( datfile ) ) != 0 ) {
		fprintf( stderr, "f[^t@C(%s)݂̏Ɏs܂\n", datfile );
	}

	/* 0.40 */
	exit_free();

	return (0);
}	/* main() */

short
chk_hist(void)
{

	char	wk_ch[256];

	if ( flg_OverWrite == 1 ) {
		/* d */
		return( 0 );
	}

	if ( flg_force == 1 ) {
		/* d(s) */
		return( 0 );
	}

	/* 1sǂ */
	while( fgets( wk_ch, 255, oldlog ) != NULL ) {
		/* dϊ */
		if ( strncmp( wk_ch, "LLC_CONVERT", 11 ) == 0 ) {
			/* sL */
			/* Ώް */
			if ( strncmp( &wk_ch[12], bltitle, strlen(bltitle) ) == 0 ) {
				/* wްނς */
				return (-1);
			}
		} else {
			/* sŖȂ */
			break;
		}
	}
	return( 0 );
}

void
exit_free()
{
	short	i;
	/* m؂̑S */
	FREE( origin_net );
	FREE( ownserial );
	for ( i = ( netxfer - 1 ); i >= 0; i-- ) {
			FREE( message_num[i] );
	}
}

/* 0.40 */
void 
helpdisp( char *name, char *mes )
{
	char	*envp;
	/* Usage\ */
	fprintf( stderr, "\n  %s\n\n",mes);
	fprintf( stderr, "  Usage:%s [[-Fconfigfile]|[-L]] [-M] [-I] logname\n", name );
	fprintf( stderr, "    [-Fconfigfile] : `̧ٖ\n" );
	fprintf( stderr, "    [-L]           : `̧ٖ̂w۸ޖ̂쐬\n" );
	fprintf( stderr, "                     -F  -L ͓Ɏwo܂\n" );
	fprintf( stderr, "    [-M]           : ڍүޕ\\n" );
	fprintf( stderr, "    [-I]           : Ro[gs\n" );
	fprintf( stderr, "    log name       : ۸̧ٖ\n" );
	fprintf( stderr, "\n" );
	if ( ( envp = getenv("LLCCFG" ) ) != NULL ) {
		fprintf( stderr, "  `t@C̃pX[%s]ɂȂĂ܁`\n", envp );
	} else if ( ( envp = getenv("HOME" ) ) != NULL ) {
		fprintf( stderr, "  `t@C̃pX[%s]ɂȂĂ܁`\n", envp );
	} else {
		fprintf( stderr, "  `t@C̃pX͓Ɏw肳ĂȂ\n" );
	}
}	/* helpdisp() */

short 
get_cfg( char *cfgfile )
{
	int		i;
	int		j;
	short	sts;
	short	wk_num;
	char	wk_ch[256];
	char	wk_dst[256];
	FILE	*cfgp;			/* `̧ٽذ   */ /* 0.30E */

	if ( disp_mes == TRUE ) {
		printf( "  process cfg file(%s)\n", cfgfile );
	}

	/* `̧ٵ 0.40 const to string cfgfile */
	if ( ( cfgp = fopen( cfgfile, "rb" ) ) == NULL ) {
		return (-1);
	}
	open_cfg = 1;
	sts = 0;
	oldsize = getsize( cfgp );

	while(1) {
		readline( cfgp );
		if ( line[0] == '#' ) {
			/* 擪 # ͺčs */
			if ( fileend == TRUE ) {	/* mod 0.40 */
				break;
			}
			continue;
		}
		/* 擪̽߰/޽ */
		for( i = 0; i < 255; i++ ) {
			if ( ( line[i] == '\0' ) || ( line[i] == ';' ) ) {	/* 0.40 for GCC */
				break;
			}
			if ( ( line[i] != ' ' ) && ( line[i] != '\t' ) ) {
				break;
			}
		}
		j = 0;
		for ( ; i < 255; i++ ) {
			if ( ( line[i] == '\0' ) || ( line[i] == ';' ) ) {	/* 0.40 for GCC */
				break;
			}
			wk_ch[j] = line[i];
			j++;
		}
		wk_ch[j] = '\0';		/* 0.40 for GCC */
		for( i = 0; i < tbl_num; i++ ) {
			if ( strncmp( wk_ch, chk_tbl[i], strlen(chk_tbl[i]) ) == 0 ) {
				if ( get_pam( wk_dst, wk_ch ) != 0 ) {
					sts = -1;
					break;
				}
				break;
			}
		}
		if ( sts < 0 ) {
			break;
		}
		switch ( i ) {
			case 0: {	/* BASENET */
				strcpy( net[0], wk_dst );
				break;
			}
			case 1: {	/* LINKNET1 */
				strcpy( net[1], wk_dst );
				break;
			}
			case 2: {	/* LINKNET2 */
				strcpy( net[2], wk_dst );
				break;
			}
			case 3: {	/* LINKNET3 */
				strcpy( net[3], wk_dst );
				break;
			}
			case 4: {	/* LINKNET4 */
				strcpy( net[4], wk_dst );
				break;
			}
			case 5: {		/* MAXNETNUM */
				netxfer = atoi( wk_dst );
				if ( netxfer > MAXXFER ) {
					fprintf( stderr, "  MESNETNUM is too big, please set below %d\n", MAXXFER );
					sts = -1;
				}
				break;
			}
			case 6: {	/* BNUMMAX */
				mesmax = atoi( wk_dst );
				if ( mesmax > MAXMES ) {
					fprintf(stderr,"  MESMAX is too big, please set below %d\n",MAXMES);
					sts = -1;
				}
				break;
			}
			case 7: {	/* HEADBORDER1 */
				strcpy( border1, wk_dst );
				break;
			}
			case 8: {	/* HEADBORDER2 */
				strcpy( border2, wk_dst );
				break;
			}
			case 9: {	/* HEADBORDER3 */
				strcpy( border3, wk_dst );
				break;
			}
			case 10: {	/* NETHEADER */
				strcpy( net_header, wk_dst );
				break;
			}
			case 11: {	/* SHEADNUM */
				shead_num = atoi( wk_dst );
				break;
			}
			case 12: {	/* BLTITLE */
				strcpy( bltitle, wk_dst );
				break;
			}
			case 13: {	/* XFERTITLE */
				strcpy( xfertitle, wk_dst );
				break;
			}
			case 14: {	/* RESTITLE */
				strcpy( response, wk_dst );
				break;
			}
			case 15: {	/* BLINKID */
				strcpy( blinkid, wk_dst );
				break;
			}
			case 16: {	/* IDMODFLG */
				idmod =  atoi( wk_dst );
				break;
			}
			case 17: {	/* LINKID1 */
				st_no[0] = atol( wk_dst );
				break;
			}
			case 18: {	/* LINKID2 */
				st_no[1] = atol( wk_dst );
				if ( st_no[1] < st_no[0] ) {
					fprintf( stderr," illigal LINKID ! %d\n", i );
					sts = -1;
				}
				break;
			}
			case 19: {	/* LINKID3 */
				st_no[2] = atol( wk_dst );
				if ( ( st_no[2] < st_no[0] ) || ( st_no[2] < st_no[1] ) ) {
					fprintf( stderr," illigal LINKID ! %d\n", i );
					sts = -1;
				}
				break;
			}
			case 20: {	/* LINKID4 */
				st_no[3] = atol( wk_dst );
				if ( ( st_no[3] < st_no[0] )
				  || ( st_no[3] < st_no[1] )
				  || ( st_no[3] < st_no[2] ) ) {
					fprintf( stderr," illigal LINKID ! %d\n", i );
					sts = -1;
				}
				break;
			}
			case 21: {	/* BAKDIR */
				strcpy( bakfile, wk_dst );
				/* ޯ̧ٖ쐬(߽) */
				sts = mk_bkname();
				break;
			}
			case 22: {	/* DATDIR */
				strcpy( datfile, wk_dst );
				if ( get_pam( datfile, wk_ch ) != 0 ) {
					sts = -1;
					break;
				}
				wk_num = strlen(datfile);
				if ( datfile[wk_num - 1] == '\\' ) {
					datfile[wk_num - 1] = '\0';
				}
				/* ߽ */
				if ( access( datfile, 0 ) != 0 ) {
					fprintf( stderr," ްޗpɎw肳ꂽިڸ؂Ȃ(T-T)[%s] \n", datfile );
					sts = -1;
					break;
				}
				strcat( datfile, "\\" );
				/* ް̧ٖ쐬 */
				sprintf( wk_ch, "%s%s", datfile, datname );
				strcpy( datfile, wk_ch );
				break;
			}
			case 23: {	/* NOMORECONV */
				if ( strncmp( wk_dst, "YES", 3 ) == 0 ) {
					/* dsȂ */
					flg_OverWrite = 0;
				} else {
					/* ds */
					flg_OverWrite = 1;
				}
				break;
			}
			case 24: {	/* LOGDIR */
				/* L邾(^^;;;; */
				break;
			}
			case 25: {	/* MAKEHIST */
				if ( strncmp( wk_dst, "YES", 3 ) == 0 ) {
					/* ǉ */
					flg_hist = 1;
				} else {
					/* ǉȂ */
					flg_hist = 0;
				}
				break;
			}
			default: {
				break;
			}
		}
		if ( sts < 0 ) {
			break;
		}
		if ( fileend == TRUE ) {	/* mod 0.40 */
			break;
		}
	}
	/* CFĢٸ۰ */
	fclose( cfgp );
	open_cfg = 0;
	if ( sts == -1 ) {
		exit(-1);
	}
#if _DEBUG
	printf( "net[0]=[%s]\n", net[0] );
	printf( "net[1]=[%s]\n", net[1] );
	printf( "net[2]=[%s]\n", net[2] );
	printf( "net[3]=[%s]\n", net[3] );
	printf( "net[4]=[%s]\n", net[4] );
	printf( "netxfer=[%d]\n", netxfer );
	printf( "mesmax=[%d]\n", mesmax );
	printf( "border1=[%s]\n", border1 );
	printf( "border2=[%s]\n", border2 );
	printf( "border3=[%s]\n", border3 );
	printf( "net_header=[%s]\n", net_header );
	printf( "shead_num=[%d]\n", shead_num );
	printf( "bltitle=[%s]\n", bltitle );
	printf( "xfertitle=[%s]\n", xfertitle );
	printf( "response=[%s]\n", response );
	printf( "blinkid=[%s]\n", blinkid );
	printf( "idmod=[%d]\n", idmod );
	printf( "st_no[0]=[%ld]\n", st_no[0] );
	printf( "st_no[1]=[%ld]\n", st_no[1] );
	printf( "st_no[2]=[%ld]\n", st_no[2] );
	printf( "st_no[3]=[%ld]\n", st_no[3] );
	printf( "bakfile=[%s]\n", bakfile );
	printf( "datfile=[%s]\n", datfile );
	printf( "flg_OverWrite=[%d]\n", flg_OverWrite );
	printf( "flg_hist=[%d]\n", flg_hist );
#endif
	return 0;
}

short
mk_bkname()
{
	short	i;
	char	wk_ch[256];
	char	*pp;
	short	wk_num;

	wk_num = strlen(bakfile);
	if ( bakfile[wk_num - 1] == '\\' ) {
		bakfile[wk_num - 1] = '\0';
	}
	/* ߽ */
	if ( access( bakfile, 0 ) != 0 ) {
		fprintf(stderr," ޯߗpɎw肳ꂽިڸ؂Ȃ(T-T)[%s] \n", bakfile );
		return (-1);
	}
	strcat( bakfile, "\\" );

	sprintf( wk_ch, "%s%s", bakfile, bakname );
	if ( access( wk_ch, 0  ) != 0  ) {
		strcpy( bakfile, wk_ch );
	} else {
		pp = strrchr( bakname, '.' );
		if ( pp != NULL ) {
			*pp = '\0';
		}
		for ( i = 0; i < 1000; i++ ) {
			sprintf( wk_ch, "%s%s.%03d", bakfile, bakname, i );
			if ( access( wk_ch, 0  ) != 0 ) {
				/* ̧ق͖ ׯ! */
				strcpy( bakfile, wk_ch );
				break;
			}
			if ( i >= 1000 ) {
				/* \gqI[o */
				fprintf( stderr, "obNAbvt@CȂ((((((( T-T)\n" );
				exit(-1);
			}
		}
	}
	return(0);
}

short
get_pam( char *dst_str, char *src_str )
{
	int		i;
	int		j;
	int		flg_hit;

	for ( i = 0; i < 256; i++ ) {
		if ( src_str[i] == '"' ) {
			/* " ܂Ž */
			i++;
			break;
		}
	}
	flg_hit = 0;
	j = 0;
	for ( ; i < 256; i++ ) {
		if ( src_str[i] != '"' ) {
			/*  " ܂ */
			dst_str[j] = src_str[i];
			j++;
		} else {
			flg_hit = 1;
			break;
		}
	}
	if ( flg_hit == 0 ) {
		fprintf( stderr, "`̧قɕss܂ (--; \n" );
		fprintf( stderr, "̍s|||||||| \n" );
		fprintf( stderr, "vvvvvvvvvvvvvvvv \n" );
		fprintf( stderr, "[%s]\n", src_str );
		return( -1 );
	}
	dst_str[j] = '\0';		/* 0.40 for GCC */
	return (0);
}	/* get_pam() */

short 
init_proc( char *dat )
{
	char	magic[8];
	long	i, j;
	short	wk;
	FILE	*fp;

	/* үðُ */
	for ( i = 0; i < mesmax; i++ ) {
		for ( j = 0; j < netxfer; j++ ) {
			message_num[j][i] = -1L;
		}
	}
	if ( access( dat, 0 ) != 0 ) {
		/* ̧ق͖ */
		fprintf( stderr, "  no dat file(%s) - 1st time\n", dat );
		return (0);
	} else {
		/* read DAT file */
		if ( ( fp = fopen( dat , "rb" ) ) != NULL ) {
			fread( &magic, 8, 1, fp );
			if ( ( strncmp( magic, "LLC_DATA", 8 ) != 0 ) ) {
				/* ް̧ق̐擪 LLC_DATA ̕񂪖ƴװ */
				fprintf( stderr, "  ERROR:%s is not dat file\n", dat );
				fclose(fp);
				return (-1);
			}
			fread( &wk, sizeof(short), 1, fp );
			if ( netxfer != wk ) {
				fprintf( stderr, "  ERROR:%s netxfer is different to cfg > %hd\n", dat, wk );
				fclose(fp);
				return (-1);
			}
			fread( &wk, sizeof(short), 1, fp );
			if ( mesmax != wk ) {
				fprintf( stderr, "  ERROR:%s mesmax is different to cfg > %hd\n", dat, wk );
				fclose(fp);
				return (-1);
			}
			fread( &linknum, sizeof(short), 1, fp );
			if ( ( linknum < 0 ) || ( linknum > mesmax ) ) {
				fprintf( stderr, "  ERROR:%s illigal linknum value %hd\n", dat, linknum );
				fclose(fp);
				return(-1);
			}
			oldlinknum = linknum;
			fread( &wrap, sizeof(short), 1, fp );
			if ( ( wrap < 0 ) || ( wrap > 1 ) ) {
				fprintf( stderr, "  ERROR:%s illigal wrap value %hd\n", dat, wrap );
				fclose(fp);
				return (-1);
			}
			if ( ( readdat( fp, (char FAR *)ownserial, ( mesmax * sizeof(long) ) ) ) != 0 ) {
				fprintf( stderr, "  ERROR:%s read ownserial data \n", dat );
				fclose(fp);
				return (-1);
			}
			for ( i = 0; i < netxfer; i++ ) {
				if ( ( readdat( fp, (char FAR *)message_num[i], ( mesmax * sizeof(long) ) ) ) != 0 ) {
					fprintf( stderr, "  ERROR:%s read messgae_num[%ld]\n", i, dat );
					fclose(fp);
					return (-1);
				}
			}
			if ( ( readdat( fp, (char FAR *)origin_net, ( mesmax * sizeof(short) ) ) ) != 0 ) {
				fprintf( stderr,"  ERROR:%s read origin_net data\n", dat );
				fclose(fp);
				return (-1);
			}
			fclose(fp);
		} else {
			/* ݎs */
			fprintf( stderr, "  unbelivable! file open error %s\n", dat );
			return (-1);
		}
	}
	return(0);
}	/* init() */

short 
store( char *dat )
{
	long	i;
	FILE	*fp;
	char	magic[9] = "LLC_DATA";

	/* read DAT file */
	if ( ( fp = fopen( dat , "wb" ) ) != NULL ) {
		if ( ( fwrite( &magic, 8, 1, fp ) ) == 0 ) {
			fprintf( stderr, "  ERROR:%s write magic \n", dat );
			fclose( fp );
			return (-1);
		}
		if ( ( fwrite( &netxfer, sizeof(short), 1, fp ) ) == 0 ) {
			fprintf( stderr, "  ERROR:%s write netxfer \n", dat );
			fclose( fp );
			return (-1);
		}
		if ( ( fwrite( &mesmax, sizeof(short), 1, fp ) ) == 0 ) {
			fprintf( stderr, "  ERROR:%s write mesmax \n", dat );
			fclose( fp );
			return (-1);
		}
		if ( ( fwrite( &linknum, sizeof(short), 1, fp ) ) == 0 ) {
			fprintf( stderr, "  ERROR:%s write linknum \n", dat );
			fclose( fp );
			return(-1);
		}
		if ( ( fwrite( &wrap, sizeof(short), 1, fp ) ) == 0 ) {
			fprintf( stderr, "  ERROR:%s write wrap \n", dat );
			fclose( fp );
			return (-1);
		}
		if ( ( writedat( fp, (char FAR *)ownserial, ( mesmax * sizeof(long) ) ) ) != 0 ) {
			fprintf( stderr, "  ERROR:%s write ownserial data \n", dat );
			fclose( fp );
			return (-1);
		}
		for ( i = 0; i < netxfer; i++ ) {
			if ( ( writedat( fp, (char FAR *)message_num[i], ( mesmax * sizeof(long) ) ) ) != 0 ) {
				fprintf( stderr, "  ERROR:%s write messgae_num[%ld]\n", i, dat );
				fclose( fp );
				return (-1);
			}
		}
		if ( ( writedat( fp, (char FAR *)origin_net, ( mesmax * sizeof(short) ) ) ) != 0 ) {
			fprintf( stderr, "  ERROR:%s write origin_net data\n", dat );
			fclose( fp );
			return (-1);
		}
		fclose(fp);
	} else {
		/* ݎs */
		fprintf( stderr, "  unbelivable! file open error %s\n", dat );
		return (-1);
	}
	return(0);
}	/* store() */

short 
procline( void )
{
	static	long	total_line_num = 0L;
	static	long	mes_line_idx = 0L;
	static	long	link_mes_idx = 0L;
	static	short	resp_flag = 0;
	long	i;
	short	j;
	long	mesno;
	long	own;
	long	shift_id;
	long	base_id;
	static	unsigned char	mesnos1[17];
	static	unsigned char	get_handle[27];

	shift_id = 0L;
	total_line_num++;
	if ( ( total_line_num == 1 ) && ( flg_hist == 1 ) ) {
		/* s */
		mk_llchist();
	}
	if ( disp_mes != TRUE ) {
		if ( ( total_line_num % 100 ) == 0 ) {
			printf( "o" );
			fflush( stdout );
		}
	}
	for ( i = 0; i < MAX_TITLE_LINE_LENGTH; i++ ) {
		if ( line[i] == '\0' ) {
			break;
		}
	}

	/* 0.40 for long line and it is not link data */
	if ( i >= ( MAX_TITLE_LINE_LENGTH - 1 ) ) {
#if _DEBUG
		printf( "long line %ld\n", total_line_num );
#endif
		if ( messtat == 6 ) {
			linknum++;
			if ( linknum >= mesmax ) {
				/* үސE𒴂 */
				wrap = TRUE;
				if ( disp_mes == TRUE ) {
					fprintf( stderr, " too many link message %ld %d %d ! wrap\n",
									 total_line_num, linknum, mesmax );
				}
				linknum = 0;
			}
		}
		messtat = 0;
		return ( messtat );
	}
	/* wb_̍ŏ(=0)琔es̏ */
	switch ( messtat ) {
		case 0: {
			/* search message headder */
			if ( !( strncmp( line, border1, strlen( border1 ) ) ) ) {
				/* ͯނ̈sڔ */
				mes_line_idx++;
				/* for no serial header */
				if ( shead_num > 0 ) {
					/* for long serial header */
					for ( i = 7; i < ( 7 + 4 + shead_num ); i++ ) {
						mesnos1[ i - 7 ] = line[i];
					}
					mesnos1[ 4 + 1 + shead_num ] = 0;
				} else {
					mesnos1[0]=0;
				}
				if ( !( strncmp( &line[ 18 + shead_num ], border2, strlen( border2 ) ) ) ) {
					/* ڽƂı߂ꂽ̂͏Ȃ */
					resp_flag = 1;
				} else {
					resp_flag = 0;
				}
				if ( shead_num > 0 ) {
					sscanf( &mesnos1[4], "%ld", &own );
					ownserial[linknum] = own;
				} else {
					ownserial[linknum] = 0;
				}
#if _DEBUG
				printf( " found header %ld in line %ld %s\n",
						mes_line_idx, total_line_num, mesnos1 );
#endif
				messtat = 1;
			}
			break;
		}
		case 1: {
			if ( !( strncmp( line, bltitle, strlen( bltitle ) ) ) ) {
				/* ȯݸĂްޖ */
				link_mes_idx++;
				message_num[0][linknum] = getnum( strchr(line,'('), '/' );      /* 0.51 */
				messtat++;
#if _DEBUG
				printf( " found net link header %5ld in line %ld serial %s bd %ld\n",
						link_mes_idx, total_line_num, mesnos1, message_num[0][linknum] );
#endif
			} else {
				/* ȯݸĂȂ */
				messtat = 0;
			}
			break;
		}
		case 2: {
			if ( shead_num == 0 ) {
				if ( line[1] == '<' ) {
					resp_flag = 1;
				}
			}
			/* ڽłȂ1sȂ */
			if ( !resp_flag ) {
				messtat++;
			}
		case 3:
		case 4:
			/* ȯݸ̓]үނ܂œǂݔ΂ */
			messtat++;
			break;
		}
		case 5:
		case 6: {
			if ( !( strncmp( line, xfertitle, strlen( xfertitle ) ) ) ) {
				if ( messtat == 5 ) {
					/* ȯݸ]үނ𔭌(Ps) */
					if ( disp_mes == TRUE ) {
						printf( " found %5ld xfer mes %5ld in line %5ld serial %010ld\n",
							link_mes_idx, message_num[0][linknum], total_line_num, ownserial[linknum] );
					}
				}
				if ( !( strncmp( &line[6], response, strlen( response ) ) ) ) {
					/* ڽ */
					i = getnum( &line[10], ':' );
					/* ڽ̏񂪂邩 */
					if ( ( mesno = searchorigin( origin_net[linknum], i ) ) != -1 ) {
						/* found original message */
						if ( !resp_flag ) {
							if ( shead_num > 0 ) {
								/* رͯނ̍s */
								makehead( linesave[0], ownserial[mesno] );
							}
							/* ͯނ2sڂ3sڂ̊Ԃڽsǉ */
							for ( j = tidx; j > 2; j-- ) {
								strcpy( linesave[j], linesave[ j - 1 ] );
							}
							tidx++;
							makeres( linesave[2], line, message_num[0][mesno] );
							if ( disp_mes == TRUE ) {
								printf( " *" );	/* modify message */
							}
						} else {
							if ( disp_mes == TRUE ) {
								printf( "  " );	/* already modify */
							}
						}
						if ( disp_mes == TRUE ) {
							printf( " response to %s:%ld is %s %ld\n",
											net[origin_net[linknum]],
											i,
											net_header,
											message_num[0][mesno] );
						}
					} else {
						/* ڽs ̂܂ */
						if ( disp_mes == TRUE ) {
							printf( "   response to %s:%ld is %s not found\n",
								net[origin_net[linknum]], i, net_header );
						}
					}
				} else {
					for ( i = 0; i < netxfer; i++ ) {
						/* ǂȯĂ]Ă */
						if ( !( strncmp( &line[6], net[i], strlen( net[i] ) ) ) ) {
							message_num[i][linknum] = getnum( &line[chknum(&line[0],' ')], ' ' );
							if ( disp_mes == TRUE ) {	/* 0.40 */
								printf( "   from %s(%ld) and local num %ld\n",
										net[i], i ,message_num[i][linknum] );
							}
							/* Ōɂ݂̂̏ȯ */
							origin_net[linknum] = i;
							break;
						}
					}
					/* rewrite board link handle */
					/* ق݂̏̐l̂̂ɕύX */
					/* #TĂȍ~̐IDƂĎ擾 */
					/* VͯނH, Vwb_łȂΉȂ */
					if ( ( line[15] == '#' ) && ( idmod == TRUE ) ) {
						/* Vͯ (ͯނق܂܂)*/
						base_id = getnum( &line[16], ':' );
						/* ǂȯĂ݂̏𔻒fĂp̼ĔԍZ */
						if ( ( i >= 1 ) || ( i <= ( MAXXFER - 1 ) ) ) {
							shift_id = st_no[ i - 1 ] + base_id;
						} else {
							/* unknown net ? */
							fprintf( stderr, " unknown net %d\n", i );
							fclose_all();
							exit_free();
							exit(1);
						}
						/* nh擾IDƋɏ */
						sprintf( get_handle, "%ld:%.15s", shift_id, &line[21] );
						*( strchr( linesave[2], 's' ) + 2 ) = 0;
						strncat( linesave[2], get_handle, 21 );
						strcat( linesave[2], "\r\n" );
					}
				}
				messtat = 6;
			} else {
				if ( messtat == 5 ) {
					/* ]Ăүނł͂Ȃ */
				} else {
					linknum++;
					if ( linknum > mesmax ) {
						/* үސE𒴂 0.40 */
						wrap = TRUE;
						fprintf( stderr, " too many link message%d %d ! wrap\n", linknum, mesmax );
						linknum = 0;
					}
				}
				messtat = 0;
			}
			break;
		}
		default: {
			break;
		}
	}
	return messtat;
}	/* procline() */


/* ϊ쐬/ */
void
mk_llchist(void)
{
	char	wk_ch[55];
	char	llc_time[30];

	get_llctime( llc_time );

	sprintf( wk_ch, "LLC_CONVERT %s %s\r\n", bltitle, llc_time );
	if ( fputs( wk_ch, newlog ) != 0 ) {
		/* ݎs */
		/* ү */
		exit_free();
		fclose_all();
		exit(-1);
	}
}

/* 擾/ϊ */
void
get_llctime( char *llc_time )
{
	/* Ԏ擾 */
	time_t	gett = time(NULL);
	/* ۰ѕϊ */
	struct tm	*gettm = localtime(&gett);
	/* ϊ */
	strcpy( llc_time, asctime(gettm) );
	llc_time[strlen(llc_time) - 1] = '\0';
}

/* TAlɕϊĕԂ */
long 
getnum( unsigned char *l1, char sep )
{
	short	j;
	long	res;		/* 0.04 correct size */
	unsigned char number[6];

	j = 0;
	while( !isdigit( *l1 ) ) {
		l1++;
	}
	do {
		number[j] = *l1;
		l1++;
		j++;
		if ( j >= 6 ) {
			break;
		}
	} while( ( *l1 ) != sep );
	number[j] = 0;
	sscanf( number, "%ld", &res );	/* 0.40 */
#if _DEBUG
	printf( "string is %s,number is %ld\n", number, res );
#endif
	return res;
}	/* getnum() */

/* search 3rd separeter from line end 0.51 */
long 
chknum( unsigned char *l1, char sep )
{
	short			i;
	unsigned char *l2;

	l2 = l1 + strlen( l1 ) - 1;	/* last char */
	for ( i = 0; i < 3; i++) {
		do {
			l2--;
		} while( ( *l2 ) != sep );
	}
#if _DEBUG
	fprintf( stderr, "chknum %d\n", (int)( l2 - l1 + 1 ) );
#endif
	return ( l2 - l1 + 1 );
}	/* chknum() */

/* ͔CɌүނT */
long 
searchorigin( short net, long bnum )
{
	long	i;

	/*  */
	for ( i = ( linknum - 1 ); i >= 0; i-- ) {
		if ( bnum == message_num[net][i] ) {
			return ( i );
		}
	}
	if ( wrap == TRUE ) {							/* 0.40 */
		for ( i = ( mesmax - 1); i >= linknum; i-- ) {
			if ( bnum == message_num[net][i] ) {
				return ( i );
			}
		}
	}
	return (-1L);
}	/* searchorigin() */

/* ڽ̼رͯނǉ */
void 
makehead( unsigned char *DstBuf, long shead_no )
{
	unsigned char	tmpBuf[30];
	unsigned char	sh_form[30];

	/* ŃXwb_쐬ȂȂȂ̂悧`(^^; */
	sprintf( sh_form, "%s%%0%dld", net_header, shead_num );

#if _DEBUG
	printf( "sh_form=[%s]\n", sh_form );
#endif

	sprintf( tmpBuf, sh_form, shead_no );
	DstBuf[15 + shead_num] = '\0';
	strcat( DstBuf, "3m<" );
	strcat( DstBuf, tmpBuf );
	strcat( DstBuf, border3 );
	strcat( DstBuf, "\r\n" );
}	/* makehead() */

/*
	l1:dest
	l2:src(in linked net)
	bnum:mes num

	if memory available,save message title!
*/
void
makeres( unsigned char *DstBuf, unsigned char *SrcBuf, long bnum )
{
	short	i;
	short	j;
	short	k;
	short	l;
	short	m;

	i = searchchar( SrcBuf, ':' );
	j = i;
	do {
		m = 0;
		j = searchchar( &SrcBuf[j], '/' ) + j;
		k = searchchar( &SrcBuf[j], ':' ) + j;
		for ( l = ( j + 1 ); l < k; l++ ) {
			if ( !( isdigit( SrcBuf[l] ) ) ) {

				DstBuf[0] = 0;
				strncat( DstBuf, &SrcBuf[j], ( k - j + 1 ) );
#if _DEBUG
				printf( "heavy title! %d %d > %s\n", j, k, DstBuf );
#endif
				j++;
				m = 1;
				break;
			}
		}
	} while ( m == 1 );

	sprintf( DstBuf, " <%ld", bnum );
	strncat( DstBuf, &SrcBuf[i], ( j - i + 1 ) );
	strcat( DstBuf, blinkid );
	strcat( DstBuf, &SrcBuf[k] );
}	/* makeres() */

short 
searchchar( unsigned char *SrcBuf, char sep )
{
	short	i;
	short	j;

	i = 0;
	j = strlen( SrcBuf );
	while ( (*SrcBuf) != sep ) {
		i++;
		SrcBuf++;
		if ( i >= j ) {
			break;
		}
	}
	return i;
}	/* searchchar() */

short	
readdat( FILE *fp, char FAR *buff, unsigned sizes )
{
	int		readsize;

	while ( sizes > 0 ) {
		if ( sizes > READ_BUFFER_SIZE ) {
			if ( ( readsize = fread( readbuff, READ_BUFFER_SIZE, 1, fp ) ) == 0 ) {
				return(-1);
			}
			MEMCPY2F(buff, readbuff, READ_BUFFER_SIZE );
			buff = buff + (long)READ_BUFFER_SIZE;
			sizes = sizes - READ_BUFFER_SIZE;
		} else {
			if ( ( readsize = fread( readbuff, sizes, 1, fp ) ) == 0 ) {
				return(-1);
			}
			MEMCPY2F( buff, readbuff, sizes );
			buff = buff + (long)sizes;
			sizes = 0;
		}
	}
	return 0;
}	/* readdat() */

short
writedat( FILE *fp, char FAR *buff, unsigned sizes )
{
	int		writesize;

	while ( sizes > 0 ) {
		if ( sizes > READ_BUFFER_SIZE ) {
			MEMCPY2N( readbuff, buff, READ_BUFFER_SIZE );
			buff = buff + (long)READ_BUFFER_SIZE;
			if ( ( writesize = fwrite( readbuff, READ_BUFFER_SIZE, 1, fp ) ) == 0 ) {
				return(-1);
			}
			sizes = sizes - READ_BUFFER_SIZE;
		} else {
			MEMCPY2N( readbuff, buff, sizes );
			buff = buff + (long)sizes;
			if ( ( writesize = fwrite( readbuff, sizes, 1, fp ) ) == 0 ) {
				return(-1);
			}
			sizes = 0;
		}
	}
	return 0;
}	/* readdat() */

void 
readline( FILE *fp )
{
	long			i;
	unsigned char	c;
	unsigned char	c1 = 0;

	line[0] = 0;
	i = 0;
	while ( ( ( c = readchar( fp ) ) != EOL ) && ( c1 != EOL0 ) ) {
		if ( fileend == TRUE ) {
			break;
		}
		line[i] = c;
		i++;
		if ( i >= MAX_LINE_LENGTH ) {	/* 0.40 check bus error */
			fprintf( stderr, " why ? too long line, over %d\n", MAX_LINE_LENGTH );
			if ( open_cfg == 1 ) {
				fclose( fp );
			}
			if ( open_log == 1 ) {
				fclose_all();
				exit_free();
			}
			exit(1);
		}
		c1 = c;
	}
	line[i] = c;
	i++;
	line[i] = 0;
}	/* readline() */

unsigned char 
readchar( FILE *fp )
{
	static long	buffidx = 0;
	static long	buffremain = 0;

	buffidx++;
	if ( buffremain == 0 ) {
		buffremain = fread( readbuff, 1, READ_BUFFER_SIZE, fp );
#if _DEBUG
		printf( "read size is %d\n", buffremain );
#endif
		oldsize = ( oldsize - buffremain );
		buffidx = 0;
	}
	buffremain--;
	if ( ( oldsize == 0 ) && ( buffremain == 0 ) ) {
		fileend = TRUE;
	}
	return readbuff[buffidx];
}	/* readchar() */

long 
getsize( FILE *fp )
{
	long i;

	fseek( fp, 0, SEEK_END );	/* 0.40 for GCC */
	i = ftell( fp );
	fseek( fp, 0, SEEK_SET );
	return (i);
}	/* getsize() */

void
fclose_all( void )
{
	if ( open_log == 1 ) {
		fclose(oldlog);
		fclose(newlog);
	}
}

/*****************************************************************************/
/*                                                                           */
/*           splpath: w蕶hCuCpXCt@CCgq       */
/*                    oB                                           */
/*                                                                           */
/*   splpath( char *src, char *drive, char *path, char *fname, char *ext,    */
/*                  short dflg, short pflg, short fflg, short eflg )         */
/*                                                                           */
/*           p[^ char  *src     ͕                            */
/*                      char  *drive   hCuo|C^            */
/*                      char  *path    pXo|C^                */
/*                      char  *fname   t@Co|C^          */
/*                      char  *ext     gqo|C^              */
/*                      short dflg     hCuowtO            */
/*                      short pflg     pXowtO                */
/*                      short fflg     t@CowtO          */
/*                      short eflg     gqowtO              */
/*                                                                           */
/*                         etO͓e 1 ȂΎos         */
/*                                                                           */
/*           ow薳C͑Ήꍇ null ƂȂ            */
/*           MSDOS ėplX680x0TowentyOneɂ͑ΉȂB            */
/*           pX̑O \ ͕tȂ                                     */
/*                                                                           */
/*                                                                           */
/*****************************************************************************/
void
splpath( char *src, char *drive, char *path, char *fname, char *ext,
					short dflg, short pflg, short fflg, short eflg )
{
	char	wk_ch[256];
	char	*ptmp;

	/* ײގ擾 */
	if ( dflg == 1 ) {
		strcpy( wk_ch, src );
		if ( strchr( wk_ch, ':' ) == NULL ) {
			/* ײޖ */
			drive[0] = '\0';
		} else {
			/* ײޖL */
			memcpy( drive, wk_ch, 2 );
			drive[2] = '\0';
		}
	} else {
		drive[0] = '\0';
	}
#if _DEBUG
printf( "drive=[%s]\n", drive );
#endif
	/* ߽擾 */
	if ( pflg == 1 ) {
		strcpy( wk_ch, src );
		ptmp = strchr( wk_ch, ':' );
		if ( ptmp != NULL ) {
			memmove( wk_ch, &wk_ch[2], ( strlen( wk_ch ) - 1 ) );
		}
		ptmp = strrchr( wk_ch, '\\' );
		if ( ptmp  == NULL ) {
			path[0] = '\0';
		} else {
			/* pX̌\\܂܂Ȃ */
			*( ptmp ) = '\0';
			strcpy( path, wk_ch );
			/* pX̑O\\܂܂Ȃ */
			if ( path[0] == '\\' ) {
				memmove( path, &path[1], strlen( path ) );
			}
		}
	} else {
		path[0] = '\0';
	}
#if _DEBUG
printf( "path=[%s]\n", path );
#endif

	/* ̧ٖ擾 */
	if ( fflg == 1 ) {
		strcpy( wk_ch, src );
		ptmp = strrchr( wk_ch, '\\' );
		if ( ptmp == NULL ) {
			ptmp = strrchr( wk_ch, '.' );
			if ( ptmp != NULL ) {
				*( ptmp ) = '\0';
			}
			strcpy( fname, wk_ch );
		} else {
			ptmp++;
			memmove( wk_ch, ptmp, ( strlen( ptmp ) + 1 ) );
			ptmp = strrchr( wk_ch, '.' );
			if ( ptmp != NULL ) {
				*( ptmp ) = '\0';
			}
			strcpy( fname, wk_ch );
		}
	} else {
		fname[0] = '\0';
	}

#if _DEBUG
printf( "fname=[%s]\n", fname );
#endif

	/* gq */
	if ( eflg == 1 ) {
		strcpy( wk_ch, src );
		ptmp = strrchr( wk_ch, '.' );
		if ( ptmp == NULL ) {
			ext[0] = '\0';
		} else {
			ptmp++;
			memmove( wk_ch, ptmp, ( strlen( ptmp ) + 1 ) );
			strcpy( ext, wk_ch );
		}
	} else {
		ext[0] = '\0';
	}

#if _DEBUG
printf( "ext=[%s]\n", ext );
#endif

#if _DEBUG
printf( "splpath DONE!\n" );
#endif

}

void
chk_ini( short para_max, char *para[], char *cfgfile, char *orgfile, char *tmpfile )
{
	char	exe_drive[3];					/* şײ */
	char	exe_path[256];					/* ş߽    */
	char	exe_name[13];					/* şٖ     */

	char	cfg_drive[3];					/* `̧ٖ     */
	char	cfg_path[256];					/* `̧ٖ     */
	char	cfg_name[13];					/* `̧ٖ     */

	char	log_drive[3];					/* ۸̧ײ  */
	char	log_path[256];					/* ۸̧߽     */
	char	log_name[13];					/* ۸̧ٖ      */
	char	log_ext[4];						/* ۸̧يgq  */

	char	wk_ch[256];						/* ܰ            */
	char	*envp;
	char	wk_dummy[2];					/* ܰа        */

	short	argidx;							/* Ұp޸ */
	short	fnam_flg;						/* ̧ٖwς׸ */
	short	i;								/* ėp޸         */
	short	wk_len;							/* ۸̧ٖ      */
#if _DEBUG
printf( "chk_ini!\n" );
#endif
	/* ̫Ē`̧ް쐬 */
	splpath( para[0], exe_drive, exe_path, exe_name, wk_dummy, 1, 1, 1, 0 );
	cfg_drive[0] = '\0';
	cfg_path[0] = '\0';
#if _DEBUG
printf( "exe_drive=[%s]\n", exe_drive );
printf( "exe_path=[%s]\n", exe_path );
printf( "exe_name=[%s]\n", exe_name );
#endif
	/* Ұ */
	fnam_flg = 0;
	argidx = 0;
	wk_len = 0;
	while ( para_max > ( ++argidx ) ) {
		if ( ( para[argidx][0] == '-' ) || ( para[argidx][0] == '/' ) ) {
			/* ڰL */
			if ( strlen( para[argidx] ) <= 1 ) {
				/* g(^^; */
				continue;
			}
			/* 啶 */
			switch ( toupper( para[argidx][1] ) ) {
				case 'M' : {
					/* ڍ׏\w */
					disp_mes = TRUE;
					break;
				}
				case 'F' : {
					/* `̧ٖw */
					if ( fnam_flg == 0 ) {
						fnam_flg = 1;
					} else {
						sprintf( wk_ch, " 'F'߼݂'L'߼݂͓ɎwłȂ̂(^^;  \n" );
						helpdisp( para[0], wk_ch );
						exit(-1);
					}
					strcpy( wk_ch, &para[argidx][2] );
					if ( wk_ch[0] == '\0' ) {
						sprintf( wk_ch, " `t@C̎w肪悧\n" );
						helpdisp( para[0], wk_ch );
						exit(-1);
					}
					/* ߽͖ */
					splpath( wk_ch, cfg_drive, cfg_path, cfg_name, wk_dummy, 1, 1, 1, 0 );
					break;
				}
				case 'L' : {
					/* `̧ٖw */
					if ( fnam_flg == 0 ) {
						fnam_flg = 2;
					} else {
						sprintf( wk_ch, " 'F'߼݂'L'߼݂͓ɎwłȂ̂(^^;  \n" );
						helpdisp( para[0], wk_ch );
						exit(-1);
					}
					break;
				}
				case 'I' : {
					/* ϊs */
					flg_force = 1;
					break;
				}
				default: {
					sprintf( wk_ch, "  ȃIvVmȂ (T-T) > %s\n", para[argidx] );
					helpdisp( para[0], wk_ch );
					printf( "bZ[WZ[ut@C̕shׂɏI܂\n" );
					exit(-1);
				}
			}
		} else {
			/* ۸̧ٖ擾 */
			strcpy( orgfile, para[argidx] );
			strcpy( wk_ch, para[argidx] );
			splpath( wk_ch, log_drive, log_path, log_name, log_ext, 1, 1, 1, 1 );
#if _DEBUG
printf( "log_drive=[%s]\n", log_drive );
printf( "log_path=[%s]\n", log_path );
printf( "log_name=[%s]\n", log_name );
printf( "log_ext=[%s]\n", log_ext );
#endif
			wk_len = strlen( log_name );
			if ( log_ext[0] == '\0' ) {
				strcpy( log_ext, "log" );
				strcat( orgfile, ".log" );
			}
		}
	}
	if ( log_name[0] == '\0' ) {
		/* ۸̧ٖw薳 (T-T  */
		helpdisp( para[0],"  LOG name undefine" );
		exit(-1);
	}

	/* `̧ٖ */
	if ( fnam_flg == 0 ) {
		strcpy( cfg_name, exe_name );
	} else if ( fnam_flg == 2 ) {
		for ( i = 0; i < wk_len; i++ ) {
			if ( isdigit(log_name[i]) != 0  ) {
				strcpy( cfg_name, log_name );
				cfg_name[i] = '\0';
				break;
			}
		}
		if ( i >= wk_len ) {
			sprintf( wk_ch, " ۸̧ٖ`̧ٖ擾oȂ̂ [%s]\n", log_name );
			helpdisp( para[0], wk_ch );
			exit(-1);
		}
	}

	/* `ٍ̧쐬 */
	if ( ( cfg_drive[0] == '\0' ) && ( cfg_path[0] == '\0' ) ) {
		/* `̧قײނ߽w肪 */
		/* ϐ擾 LLCCFG > HOME  */
		if ( ( envp = getenv( "LLCCFG" ) ) != NULL ) {
			strcpy( wk_ch, envp );
			/* ϐL */
			if ( wk_ch[strlen(wk_ch) - 1] == '\\' ) {
				/* Ō \ L */
				sprintf ( cfgfile, "%s%s.cfg", wk_ch, cfg_name );
			} else {
				/* Ō \  */
				sprintf ( cfgfile, "%s\\%s.cfg", wk_ch, cfg_name );
			}
		} else if ( ( envp = getenv( "HOME" ) ) != NULL ) {
			strcpy( wk_ch, envp );
			/* ϐL */
			if ( wk_ch[strlen(wk_ch) - 1] == '\\' ) {
				/* Ō \ L */
				sprintf ( cfgfile, "%s%s.cfg", wk_ch, cfg_name );
			} else {
				/* Ō \  */
				sprintf ( cfgfile, "%s\\%s.cfg", wk_ch, cfg_name );
			}
		} else {
				/* ϐ */
			sprintf ( cfgfile, "%s\\%s\\%s.cfg", exe_drive, exe_path, cfg_name );
		}
	} else {
		/* ײނ߽̎w肪L */
		sprintf ( cfgfile, "%s\\%s\\%s.cfg", cfg_drive, cfg_path, cfg_name );
	}

	/* ް쐬 */
	sprintf ( datname, "%s.dat", cfg_name );

	/* ޯ̧ٖ쐬 */
	sprintf ( bakname, "%s.%s", log_name, log_ext );

	/* ؍쐬 */
	if ( ( envp = getenv( "TMP" ) ) != NULL ) {
		strcpy( wk_ch, envp );
		if ( wk_ch[strlen(wk_ch) - 1] == '\\' ) {
			sprintf ( tmpfile, "%s%s\\%s.$$$", log_drive, log_path, log_name );
		} else {
			sprintf ( tmpfile, "%s\\%s%s.$$$", log_drive, log_path, log_name );
		}
	} else {
		if ( ( envp = getenv( "TEMP" ) ) != NULL ) {
			strcpy( wk_ch, envp );
			if ( wk_ch[strlen(wk_ch) - 1] == '\\' ) {
				sprintf ( tmpfile, "%s%s.$$$", wk_ch, log_name );
			} else {
				sprintf ( tmpfile, "%s\\%s.$$$", wk_ch, log_name );
			}
		} else {
			sprintf ( tmpfile, "%s\\%s\\%s.$$$", log_drive, log_path, log_name );
		}
	}
}
